//
//  RCDRecallMessageCell.m
//  SealTalk
//
//  Created by Jue on 2019/6/21.
//  Copyright © 2019 RongCloud. All rights reserved.
//

#import "RCDRecallMessageCell.h"
#import <RongIMLib/RongIMLib.h>

#define CANREEDITTIME 120

@interface RCDRecallMessageCell()

@property (nonatomic, strong) UIButton *reeditButton;

@end

@implementation RCDRecallMessageCell

-(void)setDataModel:(RCMessageModel *)model {
    [super setDataModel:model];
    RCMessage *message = [[RCIMClient sharedRCIMClient] getMessage:model.messageId];
    if (message.extra.length > 0 && [self canReeditMessage]) {
        //处理 cell 复用
        [self.reeditButton removeFromSuperview];
        
        //构造“重新编辑”按钮
        self.reeditButton = [[UIButton alloc] initWithFrame:CGRectMake(200, 1, 70, 22)];
        [self.reeditButton setTitle:@"重新编辑" forState:UIControlStateNormal];
        [self.reeditButton setTitleColor:[UIColor blueColor] forState:UIControlStateNormal];
        self.reeditButton.titleLabel.font = [UIFont systemFontOfSize:14.f];
        [self.reeditButton addTarget:self action:@selector(clickReedit) forControlEvents:UIControlEventTouchUpInside];
        
        //修改 frame
        CGRect frame = self.tipMessageLabel.frame;
        frame.size.width += 70;
        frame.origin.x -= 35;
        self.tipMessageLabel.textAlignment = NSTextAlignmentLeft;
        
        //统一主线程修改 UI
        dispatch_async(dispatch_get_main_queue(), ^{
            self.tipMessageLabel.frame = frame;
            self.tipMessageLabel.text = [NSString stringWithFormat:@"   %@",self.tipMessageLabel.text];
            [self.tipMessageLabel addSubview:self.reeditButton];
        });
        
    }
}

//点击“重新编辑”执行代理方法，为了不点击整个 cell 也触发，所以使用了点击 Url 的回调
- (void)clickReedit {
    [self.delegate didTapUrlInMessageCell:@"重新编辑" model:self.model];
}

//判断是否可以重新编辑，时间设定为 2 分钟
- (BOOL)canReeditMessage {
    RCRecallNotificationMessage *recallMessage = (RCRecallNotificationMessage*)self.model.content;
    long long cTime = [[NSDate date] timeIntervalSince1970] * 1000;
    long long ServerTime = cTime - [[RCIMClient sharedRCIMClient] getDeltaTime];
    long long interval = ServerTime - recallMessage.recallTime > 0 ? ServerTime - recallMessage.recallTime : recallMessage.recallTime - ServerTime;
    return (interval <= CANREEDITTIME * 1000);
}

@end
